

#include "BUILTIN.h"
extern OBJ _ACAST_3(OBJ);extern OBJ __ACAST_3;

#include "Nat.h"
extern OBJ _AAcceleratorC_5(OBJ,OBJ,OBJ,OBJ);OBJ __AAcceleratorC_5; /* accelerate */

extern OBJ _AAcceleratorC_5(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* accelerate */
{OBJ r;
 COPY(x3,1);
 COPY(x4,1);
 {OBJ x5;OBJ x6;OBJ x7;
  x5=_ACAST_3(x3);
  x6=_ACAST_3(x4);
  ANat_76(x5,x6,x7);
  if(ISTGPRM(x7,1)){
   FRCLS(x2,1);
   FREE(x3,1);
   FREE(x4,1);
   r=x1;
  }else{
   FREE(x1,1);
   r=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(x2,2))(x2,x3,x4);}}
 return r;}

static OBJ _mt_4_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_4_0_4(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4) 
{OBJ r;
 DCCLS(t,1);
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))ENTRY(t))(t1,t2,t3,t4);
 return r;}

static OBJ _mt_4_2_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1,t2);
 return r;}

init_AAcceleratorC()
{
 static int visited=0; if(visited) return; visited=1;
 init_ACAST();
 init_ANat();
 CLS(4,_AAcceleratorC_5,__AAcceleratorC_5);
 MTH(4,0,2,_mt_4_0_2);LZYMTH(4,0,2,_mt_4_0_2);
 MTH(4,0,4,_mt_4_0_4);LZYMTH(4,0,4,_mt_4_0_4);
 MTH(4,2,2,_mt_4_2_2);LZYMTH(4,2,2,_mt_4_2_2);}

